#include <stdlib.h>
#include <time.h>
#include <termios.h>
#include <unistd.h>
#include "classes.h"
#include <iostream>

using namespace std;

void LIDL::menu() {
  cout << "You are in room " << wherex << "," << wherey << " and you have " << shots << " arrows left.\n";
  cout << "h=Help m=Move s=Shoot q=Quit\nCommand:";

  cin >> choose;

  switch(choose) {
    case 'h': {
      help();
      break;
    }
	
    case 'm': {
      move();
      killed();
      surroundings();
      break;
    }

    case 's': {
      shoot();
      break;
    }

    case 'q': {
      quiting();
      break;
    }
    
    default: {
      cout << "Sorry unknown commmand " << choose << endl;
      break;
    };
  }	

#ifdef DEBUG
  cout << "Choose:" << choose << endl;
#endif
}

void LIDL::help() {
  cout << "\nThe goal of this game is to kill the evil Lidl monster.\n";
  cout << "Move around the map by using 'm' and the direction to move in.\n";
  cout << "Shoot into the room where you believe the Lidl monster is by \nentering 's' and the direction to shoot.\n";
  cout << "Good luck!\n\n";
}

int LIDL::show_done() {
  return done;
}

int LIDL::show_quit() {
   return quit;
}

void LIDL::quiting() {
   cout << "Are you sure? (y/n): ";
   cin >> choose;

   switch(choose) {
     case 'y': { 
       quit=1;
       break; 
     }

     case 'n': 
       break; 

     default: {
       cout << "Sorry unknown commmand " << choose;
       break;
     }
   } /* end of switch */

#ifdef DEBUG
   cout << "choose: " << choose << endl;
#endif
}

/* Main loop of the game */
int main() {
  LIDL lidl;
  lidl.info();
#ifdef DEBUG
  sleep (2);
#endif  
  lidl.surroundings();
  while ( lidl.show_done() != 1 && lidl.show_quit() != 1)
    lidl.menu();

  lidl.ending();
  return 0;
}
