#include <stdlib.h>
#include <time.h>
#include "classes.h"
#include <iostream>

using namespace std;

/*
 * The legal_move function checks if the move we just tried to make is legal. 
 * Are we trying to move through one of the outer limits for example?
 */

int LIDL::legal_move() {
  if ((direction == 110) && (wherex+1 > maxx)) { // north border
    cout << "Bad move, you're trying to run into the northern wall of darkness." << endl;
    return FALSE;

  } else if ((direction == 101) && (wherey+1 > maxy)) { // east border
    cout << "Bad move, you're trying to run into the eastern wall of china." << endl;
    return FALSE;

  } else if ((direction == 115) && (wherex-1 < 0)) { // south border
    cout << "Bad move, you're trying to run into the southern wall of light." << endl;
    return FALSE;

  } else if ((direction == 119) && (wherey-1 < 0)) { // west border
    cout << "Bad move, you're trying to run into the western wall of dragons." << endl;
    return FALSE;

  } else if ((direction != 110) && (direction != 101) && 
	     (direction != 115) && (direction != 119)) {
    cout << "Aieee, Bad move, you should not be here.\nDirection: " << direction << "," << direction << endl;

  } else {
    return TRUE;
  }
  return FALSE;
}

/*
 * This function is entered when the player decides to move the character through the 
 * labyrinth.
 */

void LIDL::move() {
  cout << "Move (n,e,s,w):";
  if (getchar()==10); // EOL can make things weird.

  while ((direction=getchar())!=10) {
    switch (direction) {

      case 110: { // e
	if (legal_move() == TRUE) {
	  wherex++;
	}
	break;
      }

      case 101: { //n
	if (legal_move() == TRUE) {
	  wherey++;
	}
	break;
      }
	
      case 115: { // s
	if (legal_move() == TRUE) {
	  wherex--;
	}
	break;
      }

      case 119: { // w
	if (legal_move() == TRUE) {
	  wherey--;
	}
	break;
      }

      default: {
	cout << "Hmmm " << direction << " is not a supported way to go.\n";
	break;
      }
    }
  }
}
