#include <stdlib.h>
#include <time.h>
#include "classes.h"
#include <iostream>

using namespace std;

/*
 * Check if the shot was a legal shot. Eg. are we trying to fire through the walls?
 */

int LIDL::legal_shot()
{
	if ((direction == 'n') and (wherex+1 > maxx)) { // north border
	  cout << "Bad shot, if you continue , you may shoot yourself through \nthe northern wall of darkness.\n";
	  return FALSE;
	  
	} else if ((direction == 'e') and (wherey+1 > maxy)) { // east border
	  cout << "Bad shot, if you continue , you may shoot yourself through \nthe eastern wall of china.\n";
	  return FALSE;

	} else if ((direction == 's') and (wherex-1 < 0)) { // south border
	  cout << "Bad shot, if you continue , you may shoot yourself through \nthe southern wall of light.\n";
	  return FALSE;

	} else if ((direction == 'w') and (wherey-1 < 0)) { // west border
	  cout << "Bad shot, if you continue , you may shoot yourself through \nthe western wall of dragons.\n";
	  return FALSE;

	} else if ((direction != 'w') and (direction != 'e') and
		   (direction != 's') /* t */ and (direction != 'n')) { /* ot */
	  cout << "Aieee, Bad shot, you should not be able to shot there.\nDirection: " << direction << endl;
	} else {
	  return TRUE;
	}
	return FALSE;
}

/*
 * This is the function entered when we want to shoot. First choose where the player
 * wants to fire, then see if it was a hit.
 */

void LIDL::shoot() {
  int OK = FALSE;
  while( OK != TRUE ) {
    cout << "Shoot (n,e,s,w): ";
    cin >> direction;

    if ( direction != 'n' and direction != 'e' and
	 direction != 's' and direction != 'w' ) {
      cout << direction << " is not an option" << endl;
    } else {
      OK = TRUE;
	}
  }

#ifdef DEBUG
  cout << "direction: " << direction << "," << (int) direction << endl;
#endif
  
  switch (direction)
    {
      case 'n': { //north
	if (legal_shot() == TRUE) {
	  switch(room[wherex-1][wherey]) {
	    case MONSTER: {
	      cout << "You killed the monster!\nCongratulations!\n";
	      done=1;
	      points=points+5+shots;
	      break;
	    };
	      
	    case BAT: {
	      cout << "You killed a fruit eating bat\n";
	      shots--;
	      room[wherex-1][wherey]=EMPTY;
	      points++;
	      break;
	    };
	    
	    default: {
	      cout << "What are you shooting at? There is nothing there!\n";
	      shots--;
	      break;
	    };
	  }
	}
	break;
      }

      case 'e': { //east
        if (legal_shot() == TRUE) {
	  switch(room[wherex][wherey+1]) {
  	    case MONSTER: {
	      cout << "You killed the monster!\nCongratulations!\n";
	      done=1;
	      points=points+5+shots;
	      break;
	    };
	      
	    case BAT: {
	      cout << "You killed a fruit eating bat\n";
	      shots--;
	      room[wherex][wherey+1]=EMPTY;
	      points++;
	      break;
	    };

  	    default: {
	      cout << "What are you shooting at? There is nothing there!\n";
	      shots--;
	      break;
	    };
	  }
	}
	break;
      }

      case 's': { //south
	if (legal_shot() == TRUE) {
	  switch(room[wherex+1][wherey]) {
	    case MONSTER: {
	      cout << "You killed the monster!\nCongratulations!\n";
	      done=1;
	      points=points+5+shots;
	      break;
	    };
	      
	    case BAT: {
	      cout << "You killed a fruit eating bat\n";
	      shots--;
	      room[wherex+1][wherey]=EMPTY;
	      points++;
	      break;
	    };

	    default: {
	      cout << "What are you shooting at? There is nothing there!\n";
	      break;
	    };
	  }
	}
	break;
      }

      case 'w': { //west
	if (legal_shot() == TRUE) {
	  switch(room[wherex][wherey-1]) {
	    case MONSTER: {
	      cout << "You killed the monster!\nCongratulations!\n";
	      done=1;
	      points=points+5+shots;
	      break;
	    };
	      
	    case BAT: {
	      cout << "You killed a fruit eating bat\n";
	      shots--;
	      room[wherex][wherey-1]=EMPTY;
	      points++;
	      break;
	    };

	    default: {
	      cout << "What are you shooting at? There is nothing there!\n";
	      shots--;
	      break;
	    };
	  }
	}
	break;
      }
    }
  
  if (shots<=0)
    {
      cout << "The baby lidl monsters of this cave found out that you don't have a arrows left and they are planing to gnaw you heels of...\n";
      done=1;
    }
}
